searchNodes=[{"doc":"Eakins is a simple library that allows you to store image urls in your ecto schemas. How it works Eakins relies on having a known storage url embedded in your schema. This url is then used to create a display url that takes advantage of an image resizing proxy to show the image at the correct size and aspect ratio. Because an image proxy is used, changing your image sizes and aspects can be done at any time, and won't require you to go through all your images via a job queueuing system. Integrating it into your schemas To use Eakins with a schema, that schema must have a column with a :map datatype and a version column with an :integer data type. Then, use Eakins.Schema in your schema module and declare either an image_map or image_list field defmodule UserSchema do use Ecto.Schema use Eakins.Schema schema &quot;users&quot; do field :first_name , :string field :last_name , :name image_map :avatars end end Your schema is now has an avatar image map, where you can store multiple images under different keys. See Eakins.Schema for more information on what you can do with the field and see Eakins.Image.Display for how to generate URLs with the field's value.","ref":"Eakins.html","title":"Eakins","type":"module"},{"doc":"An aspect ratio","ref":"Eakins.html#t:aspect/0","title":"Eakins.aspect/0","type":"type"},{"doc":"an alias for an aspect ratio","ref":"Eakins.html#t:aspect_alias/0","title":"Eakins.aspect_alias/0","type":"type"},{"doc":"A height in pixels","ref":"Eakins.html#t:custom_height/0","title":"Eakins.custom_height/0","type":"type"},{"doc":"The gravity of an image. When resizing, the image's gravity holds it to that position.","ref":"Eakins.html#t:gravity/0","title":"Eakins.gravity/0","type":"type"},{"doc":"The height of an image in pixels","ref":"Eakins.html#t:height/0","title":"Eakins.height/0","type":"type"},{"doc":"","ref":"Eakins.html#t:image/0","title":"Eakins.image/0","type":"type"},{"doc":"The index of an image in an image list","ref":"Eakins.html#t:index/0","title":"Eakins.index/0","type":"type"},{"doc":"","ref":"Eakins.html#t:key/0","title":"Eakins.key/0","type":"type"},{"doc":"The name of an image in an image map","ref":"Eakins.html#t:name/0","title":"Eakins.name/0","type":"type"},{"doc":"","ref":"Eakins.html#t:named_size/0","title":"Eakins.named_size/0","type":"type"},{"doc":"The size of an image either via a named size or in pixels","ref":"Eakins.html#t:size/0","title":"Eakins.size/0","type":"type"},{"doc":"A displayable image instance When created with a Eakins.Image.Stored image, this module creates an image suitable for display via our image proxy.","ref":"Eakins.Image.Display.html","title":"Eakins.Image.Display","type":"module"},{"doc":"","ref":"Eakins.Image.Display.html#imgproxy_scheme/0","title":"Eakins.Image.Display.imgproxy_scheme/0","type":"function"},{"doc":"","ref":"Eakins.Image.Display.html#new/3","title":"Eakins.Image.Display.new/3","type":"function"},{"doc":"","ref":"Eakins.Image.Display.html#t:t/0","title":"Eakins.Image.Display.t/0","type":"type"},{"doc":"","ref":"Eakins.Image.Stored.html","title":"Eakins.Image.Stored","type":"module"},{"doc":"","ref":"Eakins.Image.Stored.html#changeset/2","title":"Eakins.Image.Stored.changeset/2","type":"function"},{"doc":"","ref":"Eakins.Image.Stored.html#from_upload/2","title":"Eakins.Image.Stored.from_upload/2","type":"function"},{"doc":"","ref":"Eakins.Image.Stored.html#new/3","title":"Eakins.Image.Stored.new/3","type":"function"},{"doc":"","ref":"Eakins.Image.Stored.html#t:name/0","title":"Eakins.Image.Stored.name/0","type":"type"},{"doc":"","ref":"Eakins.Image.Stored.html#t:t/0","title":"Eakins.Image.Stored.t/0","type":"type"},{"doc":"A schema extension that allows you to attach images to a model. To use this extension, your schema must define an integer field called :version and a map field. The map field's name should be the same as the image map or image list that you will define. To configure this module, just use it below your usage of Eakins.Schema . Then, define eith an image_map or image_list in your schema. defmodule Myapp.User do use Ecto.Schema use Eakins.Schema schema &quot;users&quot; do field :first_name , :string field :last_name , :string image_map :avatars end end The previous incantation will define an image map and associate with the images field. The name of the image list or the image map should be plural, as the functions that are generated make use of this name to provide access to the entire list (the plural functions) or a single image (the singular functions). Image Maps An image map is an unordered collection of named images. Eakins in this collection can be added, removed or accessed by their name. Similarly, you can use the generated functions to retrieve a displayable instance at any aspect ratio or size. If the name of the image map is images , the following functions are generated: display_image/4 - Returns a displayable instance of the named image display_images/3 - Returns all images associated with this model. The return values are displayable. find_image/2 - Finds the image with the given name delete_image/2 - Deletes the image with the given name has_image?/2 - Returns true if there is an image with the given name put_image/3 - Sets the image with the given name, replacing any existing image. find_image/2 - Finds the image on this model with the given name. The returned image is not displayable Image Lists An image list is an ordered list of images,. Images in an image list are able to be retrieved, deleted and added by index If the name of the image list is images , the following functions are generated: display_image/4 - Returns a displayable image with the given index or nil if one doesn't exist. display_images/3 - Returns all images in the image list at the given aspect ratio and height. find_image/2 - Returns the image with the given index, if it exists and nil otherwise. delete_image_at/2 - When applied to a changeset, deletes the image with the given index. replace_image_at/3 - Sets the image with the given index on this image list. This will replace any image with the same index. insert_image_at/3 - Inserts an image into the image list at the specified index. This will grow the list image_at /2 - Finds the image in this image list with the given index. The returned image is not displayable. Generated functions Adding an image list or an image map to your model creates adds helper functions that let you modify the image containers as well as functions that generate images suitable for display. The generated functions are fully documented and have proper typespecs. Saving new images To create a new image from a Plug.Upload , pass it in the image argument to one of the generated put functions. The image will be saved to backend storage during the attached model's update. for example def save_avatar ( % User { } = user , % Plug.Upload { } = image ) do user |&gt; User . changeset ( %{ } ) |&gt; User . put_image ( :avatar , image ) |&gt; Repo . update ( ) end If the function completes correctly, the image will be persisted in the configured storage. Deleting old images Old images must be deleted after the transaction completes, as we can't be guaranteed that the model will be saved correctly. To delete old images, use an Ecto.Multi def replace_avatar ( % User { } = user , % Plug.Upload { } = avatar ) do old_image = User . find_image ( user , :avatar ) changeset = user |&gt; User . changeset ( %{ } ) |&gt; User . put_image ( :avatar , avatar ) Multi . new ( ) |&gt; Multi . update ( :update_user , changeset ) |&gt; Multi . run ( :delete_old_image , fn _ , _ -&gt; case Eakins.Storage . delete ( user , old_image ) do :ok -&gt; { :ok , old_image } error -&gt; error end ) |&gt; Repo . transaction ( ) |&gt; case do { :ok , %{ update_user : user } } -&gt; { :ok , user } { : error , _failed_op , failed_value , _ } -&gt; { :error , failed_value } end","ref":"Eakins.Schema.html","title":"Eakins.Schema","type":"module"},{"doc":"","ref":"Eakins.Schema.html#image_list/1","title":"Eakins.Schema.image_list/1","type":"macro"},{"doc":"","ref":"Eakins.Schema.html#image_map/1","title":"Eakins.Schema.image_map/1","type":"macro"},{"doc":"The storage interface for uploaded images","ref":"Eakins.Storage.html","title":"Eakins.Storage","type":"behaviour"},{"doc":"","ref":"Eakins.Storage.html#delete/2","title":"Eakins.Storage.delete/2","type":"function"},{"doc":"","ref":"Eakins.Storage.html#c:delete/2","title":"Eakins.Storage.delete/2","type":"callback"},{"doc":"","ref":"Eakins.Storage.html#delete_all/0","title":"Eakins.Storage.delete_all/0","type":"function"},{"doc":"","ref":"Eakins.Storage.html#c:delete_all/0","title":"Eakins.Storage.delete_all/0","type":"callback"},{"doc":"","ref":"Eakins.Storage.html#exists?/2","title":"Eakins.Storage.exists?/2","type":"function"},{"doc":"","ref":"Eakins.Storage.html#c:exists?/2","title":"Eakins.Storage.exists?/2","type":"callback"},{"doc":"","ref":"Eakins.Storage.html#store/2","title":"Eakins.Storage.store/2","type":"function"},{"doc":"","ref":"Eakins.Storage.html#c:store/2","title":"Eakins.Storage.store/2","type":"callback"},{"doc":"","ref":"Eakins.Storage.html#t:image/0","title":"Eakins.Storage.image/0","type":"type"},{"doc":"","ref":"Eakins.Storage.html#t:parent_schema/0","title":"Eakins.Storage.parent_schema/0","type":"type"},{"doc":"Development-only local storage for image uploads.","ref":"Eakins.Storage.Local.html","title":"Eakins.Storage.Local","type":"module"},{"doc":"","ref":"Eakins.Storage.Local.html#storage_root/0","title":"Eakins.Storage.Local.storage_root/0","type":"function"},{"doc":"S3 Based storage for uploaded images","ref":"Eakins.Storage.S3.html","title":"Eakins.Storage.S3","type":"module"},{"doc":"","ref":"Eakins.Storage.S3.html#bucket/0","title":"Eakins.Storage.S3.bucket/0","type":"function"},{"doc":"Updates one of the images in a schema's image map","ref":"Eakins.UseCases.DeleteSchemaImage.html","title":"Eakins.UseCases.DeleteSchemaImage","type":"module"},{"doc":"","ref":"Eakins.UseCases.DeleteSchemaImage.html#call/5","title":"Eakins.UseCases.DeleteSchemaImage.call/5","type":"function"},{"doc":"Deletes several images from a schema.","ref":"Eakins.UseCases.DeleteSchemaImages.html","title":"Eakins.UseCases.DeleteSchemaImages","type":"module"},{"doc":"","ref":"Eakins.UseCases.DeleteSchemaImages.html#call/4","title":"Eakins.UseCases.DeleteSchemaImages.call/4","type":"function"},{"doc":"Abstracting operations across our image storage types","ref":"Eakins.UseCases.Reflection.html","title":"Eakins.UseCases.Reflection","type":"behaviour"},{"doc":"","ref":"Eakins.UseCases.Reflection.html#add_or_update_image/4","title":"Eakins.UseCases.Reflection.add_or_update_image/4","type":"function"},{"doc":"Creates a changeset that updates an image with the given key in the provided schema","ref":"Eakins.UseCases.Reflection.html#c:add_or_update_image/4","title":"Eakins.UseCases.Reflection.add_or_update_image/4","type":"callback"},{"doc":"","ref":"Eakins.UseCases.Reflection.html#delete_image/4","title":"Eakins.UseCases.Reflection.delete_image/4","type":"function"},{"doc":"Creates a changeset that deletes the image with the given key","ref":"Eakins.UseCases.Reflection.html#c:delete_image/4","title":"Eakins.UseCases.Reflection.delete_image/4","type":"callback"},{"doc":"","ref":"Eakins.UseCases.Reflection.html#find_image/3","title":"Eakins.UseCases.Reflection.find_image/3","type":"function"},{"doc":"Finds an image in an image container","ref":"Eakins.UseCases.Reflection.html#c:find_image/3","title":"Eakins.UseCases.Reflection.find_image/3","type":"callback"},{"doc":"","ref":"Eakins.UseCases.Reflection.html#has_image?/3","title":"Eakins.UseCases.Reflection.has_image?/3","type":"function"},{"doc":"Returns true if the image container has the image with the given key","ref":"Eakins.UseCases.Reflection.html#c:has_image?/3","title":"Eakins.UseCases.Reflection.has_image?/3","type":"callback"},{"doc":"","ref":"Eakins.UseCases.Reflection.html#remove_image_from_storage/3","title":"Eakins.UseCases.Reflection.remove_image_from_storage/3","type":"function"},{"doc":"Removes the given image from the underlying storage mechanism","ref":"Eakins.UseCases.Reflection.html#c:remove_image_from_storage/3","title":"Eakins.UseCases.Reflection.remove_image_from_storage/3","type":"callback"},{"doc":"","ref":"Eakins.UseCases.Reflection.html#update_image/4","title":"Eakins.UseCases.Reflection.update_image/4","type":"function"},{"doc":"Updates the image in the image container","ref":"Eakins.UseCases.Reflection.html#c:update_image/4","title":"Eakins.UseCases.Reflection.update_image/4","type":"callback"},{"doc":"","ref":"Eakins.UseCases.Reflection.html#t:container_name/0","title":"Eakins.UseCases.Reflection.container_name/0","type":"type"},{"doc":"Reflection utilities for image lists","ref":"Eakins.UseCases.Reflection.List.html","title":"Eakins.UseCases.Reflection.List","type":"module"},{"doc":"","ref":"Eakins.UseCases.Reflection.List.html#fn_name/3","title":"Eakins.UseCases.Reflection.List.fn_name/3","type":"function"},{"doc":"Reflection utilities for image maps","ref":"Eakins.UseCases.Reflection.Map.html","title":"Eakins.UseCases.Reflection.Map","type":"module"},{"doc":"","ref":"Eakins.UseCases.Reflection.Map.html#fn_name/3","title":"Eakins.UseCases.Reflection.Map.fn_name/3","type":"function"},{"doc":"Updates one of the images in a schema's image map","ref":"Eakins.UseCases.UpdateSchemaImage.html","title":"Eakins.UseCases.UpdateSchemaImage","type":"module"},{"doc":"","ref":"Eakins.UseCases.UpdateSchemaImage.html#call/2","title":"Eakins.UseCases.UpdateSchemaImage.call/2","type":"function"},{"doc":"","ref":"Eakins.UseCases.UpdateSchemaImage.html#new/3","title":"Eakins.UseCases.UpdateSchemaImage.new/3","type":"function"},{"doc":"","ref":"Eakins.UseCases.UpdateSchemaImage.html#t:t/0","title":"Eakins.UseCases.UpdateSchemaImage.t/0","type":"type"},{"doc":"Eakins is a library that takes the pain out of image management in Ecto. It allows you to have pluggable storage backends for your image data and pluggable front-ends for all your rescaling needs. Currently, it supports storing images in s3 or on the file system, and supports Imgproxy as a serving frontend.","ref":"readme.html","title":"Eakins","type":"extras"},{"doc":"Eakins is available in hex, and can be installed by adding eakins to your list of dependencies in mix.exs : def deps do [ { :eakins , &quot;~&gt; 0.1.0&quot; } ] end Documentation can be generated with ExDoc and published on HexDocs . Once published, the docs can be found at https://hexdocs.pm/eakins . Naming Eakins is named after Thomas Eakins , an American realist painter who painted pretty clouds.","ref":"readme.html#installation","title":"Eakins - Installation","type":"extras"}]